using System;
using System.Collections.ObjectModel;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    public class ApplicationGroup
    {
        IAzApplicationGroup group;

        internal ApplicationGroup(IAzApplicationGroup group)
        {
            this.group = group;
        }

        public void AddAppMember(string member)
        {
            group.AddAppMember(member, null);
        }

        public void AddAppNonMember(string member)
        {
            group.AddAppNonMember(member, null);
        }

        public void AddMember(string member)
        {
            group.AddMember(member, null);
        }

        public void AddMemberName(string member)
        {
            group.AddMemberName(member, null);
        }

        public void AddNonMember(string member)
        {
            group.AddNonMember(member, null);
        }

        public void AddNonMemberName(string member)
        {
            group.AddNonMemberName(member, null);
        }

        public void AddPropertyItem(int propertyId, object propertyValue)
        {
            group.AddPropertyItem(propertyId, propertyValue, null);
        }

        public ReadOnlyCollection<string> AppMembers
        {
            get { return Utils.ToStringArray(group.AppMembers); }
        }

        public ReadOnlyCollection<string> AppNonMembers
        {
            get { return Utils.ToStringArray(group.AppNonMembers); }
        }

        public void DeleteAppMember(string member)
        {
            group.DeleteAppMember(member, null);
        }

        public void DeleteAppNonMember(string member)
        {
            group.DeleteAppNonMember(member, null);
        }

        public void DeleteMember(string member)
        {
            group.DeleteMember(member, null);
        }

        public void DeleteMemberName(string member)
        {
            group.DeleteMemberName(member, null);
        }

        public void DeleteNonMember(string member)
        {
            group.DeleteNonMember(member, null);
        }

        public void DeleteNonMemberName(string member)
        {
            group.DeleteNonMemberName(member, null);
        }

        public void DeletePropertyItem(int propertyId, object propertyValue)
        {
            group.DeletePropertyItem(propertyId, propertyValue, null);
        }

        public string Description
        {
            get { return group.Description; }
            set { group.Description = value; }
        }

        public object GetProperty(int propertyId)
        {
            return group.GetProperty(propertyId, null);
        }

        public string LdapQuery
        {
            get { return group.LdapQuery; }
            set { group.LdapQuery = value; }
        }

        public ReadOnlyCollection<string> Members
        {
            get { return Utils.ToStringArray(group.Members); }
        }

        public ReadOnlyCollection<string> MembersName
        {
            get { return Utils.ToStringArray(group.MembersName); }
        }

        public string Name
        {
            get { return group.Name; }
            set { group.Name = value; }
        }

        public ReadOnlyCollection<string> NonMembers
        {
            get { return Utils.ToStringArray(group.NonMembers); }
        }

        public ReadOnlyCollection<string> NonMembersName
        {
            get { return Utils.ToStringArray(group.NonMembersName); }
        }

        public void SetProperty(int propertyId, object propertyValue)
        {
            group.SetProperty(propertyId, propertyValue, null);
        }

        public void Submit(int flags)
        {
            group.Submit(flags, null);
        }

        public int Type
        {
            get { return group.Type; }
            set { group.Type = value; }
        }

        public bool Writable
        {
            get { return Convert.ToBoolean(group.Writable); }
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
