using System;
using System.Collections.ObjectModel;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    public class ClientContext
    {
        static object[] empty = new object[0];
        IAzClientContext clientContext;

        internal ClientContext(IAzClientContext clientContext)
        {
            this.clientContext = clientContext;
        }

        public int AccessCheck(string objectName, string scopeName, int operationId)
        {
            return (int)((object[])clientContext.AccessCheck(objectName, new object[] { scopeName }, new object[] { operationId }, empty, empty, empty, empty, empty))[0];
        }

        public string GetBusinessRuleString()
        {
            return clientContext.GetBusinessRuleString();
        }

        public object GetProperty(int propertyId)
        {
            return clientContext.GetProperty(propertyId, null);
        }

        public ReadOnlyCollection<string> GetRoles(string scopeName)
        {
            return Utils.ToStringArray(clientContext.GetRoles(scopeName));
        }

        public string RoleForAccessCheck
        {
            get { return clientContext.RoleForAccessCheck; }
            set { clientContext.RoleForAccessCheck = value; }
        }

        public string UserCanonical
        {
            get { return clientContext.UserCanonical; }
        }

        public string UserDisplay
        {
            get { return clientContext.UserDisplay; }
        }

        public string UserDn
        {
            get { return clientContext.UserDn; }
        }

        public string UserDnsSamCompat
        {
            get { return clientContext.UserDnsSamCompat; }
        }

        public string UserGuid
        {
            get { return clientContext.UserGuid; }
        }

        public string UserSamCompat
        {
            get { return clientContext.UserSamCompat; }
        }

        public string UserUpn
        {
            get { return clientContext.UserUpn; }
        }

        public override string ToString()
        {
            return UserCanonical;
        }
    }
}
