using System;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    public class Operation
    {
        IAzOperation operation;

        internal Operation(IAzOperation operation)
        {
            this.operation = operation;
        }

        public string ApplicationData
        {
            get { return operation.ApplicationData; }
            set { operation.ApplicationData = value; }
        }

        public string Description
        {
            get { return operation.Description; }
            set { operation.Description = value; }
        }

        public object GetProperty(int propertyId)
        {
            return operation.GetProperty(propertyId, null);
        }

        public string Name
        {
            get { return operation.Name; }
            set { operation.Name = value; }
        }

        public int OperationID
        {
            get { return operation.OperationID; }
            set { operation.OperationID = value; }
        }

        public void SetProperty(int propertyId, object propertyValue)
        {
            operation.SetProperty(propertyId, propertyValue, null);
        }

        public void Submit(int flags)
        {
            operation.Submit(flags, null);
        }

        public bool Writable
        {
            get { return Convert.ToBoolean(operation.Writable); }
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
