using System;
using System.Collections.ObjectModel;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    public class Role
    {
        IAzRole role;

        internal Role(IAzRole role)
        {
            this.role = role;
        }

        public void AddAppMember(string member)
        {
            role.AddAppMember(member, null);
        }

        public void AddMember(string member)
        {
            role.AddMember(member, null);
        }

        public void AddMemberName(string memberName)
        {
            role.AddMemberName(memberName, null);
        }

        public void AddOperation(string operationName)
        {
            role.AddOperation(operationName, null);
        }

        public void AddPropertyItem(int propertyId, object propertyValue)
        {
            role.AddPropertyItem(propertyId, propertyValue, null);
        }

        public void AddTask(string taskName)
        {
            role.AddTask(taskName, null);
        }

        public ReadOnlyCollection<string> AppMembers
        {
            get { return Utils.ToStringArray(role.AppMembers); }
        }

        public string ApplicationData
        {
            get { return role.ApplicationData; }
            set { role.ApplicationData = value; }
        }

        public void DeleteAppMember(string member)
        {
            role.DeleteAppMember(member, null);
        }

        public void DeleteMember(string member)
        {
            role.DeleteMember(member, null);
        }

        public void DeleteMemberName(string memberName)
        {
            role.DeleteMemberName(memberName, null);
        }

        public void DeleteOperation(string operationName)
        {
            role.DeleteOperation(operationName, null);
        }

        public void DeletePropertyItem(int propertyId, object propertyValue)
        {
            role.DeletePropertyItem(propertyId, propertyValue, null);
        }

        public void DeleteTask(string taskName)
        {
            role.DeleteTask(taskName, null);
        }

        public string Description
        {
            get { return role.Description; }
            set { role.Description = value; }
        }

        public object GetProperty(int propertyId)
        {
            return role.GetProperty(propertyId, null);
        }

        public ReadOnlyCollection<string> Members
        {
            get { return Utils.ToStringArray(role.Members); }
        }

        public ReadOnlyCollection<string> MembersName
        {
            get { return Utils.ToStringArray(role.MembersName); }
        }

        public string Name
        {
            get { return role.Name; }
            set { role.Name = value; }
        }

        public ReadOnlyCollection<string> Operations
        {
            get { return Utils.ToStringArray(role.Operations); }
        }

        public void SetProperty(int propertyId, object propertyValue)
        {
            role.SetProperty(propertyId, propertyValue, null);
        }

        public void Submit(int flags)
        {
            role.Submit(flags, null);
        }

        public ReadOnlyCollection<string> Tasks
        {
            get { return Utils.ToStringArray(role.Tasks); }
        }

        public bool Writable
        {
            get { return Convert.ToBoolean(role.Writable); }
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
