using System;
using System.Collections.ObjectModel;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    public class Scope
    {
        IAzScope scope;

        public Scope(IAzScope scope)
        {
            this.scope = scope;
        }

        public void AddPolicyAdministrator(string admin)
        {
            scope.AddPolicyAdministrator(admin, null);
        }

        public void AddPolicyAdministratorName(string adminName)
        {
            scope.AddPolicyAdministratorName(adminName, null);
        }

        public void AddPolicyReader(string reader)
        {
            scope.AddPolicyReader(reader, null);
        }

        public void AddPolicyReaderName(string readerName)
        {
            scope.AddPolicyReaderName(readerName, null);
        }

        public void AddPropertyItem(int propertyId, object propertyValue)
        {
            scope.AddPropertyItem(propertyId, propertyValue, null);
        }

        public string ApplicationData
        {
            get { return scope.ApplicationData; }
            set { scope.ApplicationData = value; }
        }

        public ReadOnlyCollection<ApplicationGroup> ApplicationGroups
        {
            get { return Utils.ToApplicationGroupArray(scope.ApplicationGroups); }
        }

        public bool BizrulesWritable
        {
            get { return Convert.ToBoolean(scope.BizrulesWritable); }
        }

        public bool CanBeDelegated
        {
            get { return Convert.ToBoolean(scope.CanBeDelegated); }
        }

        public ApplicationGroup CreateApplicationGroup(string groupName)
        {
            return new ApplicationGroup(scope.CreateApplicationGroup(groupName, null));
        }

        public Role CreateRole(string roleName)
        {
            return new Role(scope.CreateRole(roleName, null));
        }

        public Task CreateTask(string taskName)
        {
            return new Task(scope.CreateTask(taskName, null));
        }

        public void DeleteApplicationGroup(string groupName)
        {
            scope.DeleteApplicationGroup(groupName, null);
        }

        public void DeletePolicyAdministrator(string admin)
        {
            scope.DeletePolicyAdministrator(admin, null);
        }

        public void DeletePolicyAdministratorName(string adminName)
        {
            scope.DeletePolicyAdministratorName(adminName, null);
        }

        public void DeletePolicyReader(string reader)
        {
            scope.DeletePolicyReader(reader, null);
        }

        public void DeletePolicyReaderName(string readerName)
        {
            scope.DeletePolicyReaderName(readerName, null);
        }

        public void DeletePropertyItem(int propertyId, object propertyValue)
        {
            scope.DeletePropertyItem(propertyId, propertyValue, null);
        }

        public void DeleteRole(string roleName)
        {
            scope.DeleteRole(roleName, null);
        }

        public void DeleteTask(string taskName)
        {
            scope.DeleteTask(taskName, null);
        }

        public string Description
        {
            get { return scope.Description; }
            set { scope.Description = value; }
        }

        public object GetProperty(int propertyId)
        {
            return scope.GetProperty(propertyId, null);
        }

        public string Name
        {
            get { return scope.Name; }
            set { scope.Name = value; }
        }

        public ApplicationGroup OpenApplicationGroup(string groupName)
        {
            return new ApplicationGroup(scope.OpenApplicationGroup(groupName, null));
        }

        public Role OpenRole(string roleName)
        {
            return new Role(scope.OpenRole(roleName, null));
        }

        public Task OpenTask(string taskName)
        {
            return new Task(scope.OpenTask(taskName, null));
        }

        public ReadOnlyCollection<string> PolicyAdministrators
        {
            get { return Utils.ToStringArray(scope.PolicyAdministrators); }
        }

        public ReadOnlyCollection<string> PolicyAdministratorsName
        {
            get { return Utils.ToStringArray(scope.PolicyAdministratorsName); }
        }

        public ReadOnlyCollection<string> PolicyReaders
        {
            get { return Utils.ToStringArray(scope.PolicyReaders); }
        }

        public ReadOnlyCollection<string> PolicyReadersName
        {
            get { return Utils.ToStringArray(scope.PolicyReadersName); }
        }

        public ReadOnlyCollection<Role> Roles
        {
            get { return Utils.ToRoleArray(scope.Roles); }
        }

        public void SetProperty(int propertyId, object propertyValue)
        {
            scope.SetProperty(propertyId, propertyValue, null);
        }

        public void Submit(int flags)
        {
            scope.Submit(flags, null);
        }

        public ReadOnlyCollection<Task> Tasks
        {
            get { return Utils.ToTaskArray(scope.Tasks); }
        }

        public bool Writable
        {
            get { return Convert.ToBoolean(scope.Writable); }
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
