using System;
using System.Collections.ObjectModel;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    public class Task
    {
        IAzTask task;

        internal Task(IAzTask task)
        {
            this.task = task;
        }

        public void AddOperation(string operationName)
        {
            task.AddOperation(operationName, null);
        }

        public void AddPropertyItem(int propertyId, object propertyValue)
        {
            task.AddPropertyItem(propertyId, propertyValue, null);
        }

        public void AddTask(string taskName)
        {
            task.AddTask(taskName, null);
        }

        public string ApplicationData
        {
            get { return task.ApplicationData; }
            set { task.ApplicationData = value; }
        }

        public string BizRule
        {
            get { return task.BizRule; }
            set { task.BizRule = value; }
        }

        public string BizRuleImportedPath
        {
            get { return task.BizRuleImportedPath; }
            set { task.BizRuleImportedPath = value; }
        }

        public string BizRuleLanguage
        {
            get { return task.BizRuleLanguage; }
            set { task.BizRuleLanguage = value; }
        }

        public void DeleteOperation(string operationName)
        {
            task.DeleteOperation(operationName, null);
        }

        public void DeletePropertyItem(int propertyId, object propertyValue)
        {
            task.DeletePropertyItem(propertyId, propertyId, null);
        }

        public void DeleteTask(string taskName)
        {
            task.DeleteTask(taskName, null);
        }

        public string Description
        {
            get { return task.Description; }
            set { task.Description = value; }
        }

        public object GetProperty(int propertyId)
        {
            return task.GetProperty(propertyId, null);
        }

        public bool IsRoleDefinition
        {
            get { return Convert.ToBoolean(task.IsRoleDefinition); }
            set { task.IsRoleDefinition = Convert.ToInt32(value); }
        }

        public string Name
        {
            get { return task.Name; }
            set { task.Name = value; }
        }

        public ReadOnlyCollection<string> Operations
        {
            get { return Utils.ToStringArray(task.Operations); }
        }

        public void SetProperty(int propertyId, object propertyValue)
        {
            task.SetProperty(propertyId, propertyValue, null);
        }

        public void Submit(int flags)
        {
            task.Submit(flags, null);
        }

        public ReadOnlyCollection<string> Tasks
        {
            get { return Utils.ToStringArray(task.Tasks); }
        }

        public bool Writable
        {
            get { return Convert.ToBoolean(task.Writable); }
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
