using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Microsoft.Interop.Security.AzRoles;

namespace Microsoft.AzRoles
{
    static class Utils
    {
        public static ReadOnlyCollection<string> ToStringArray(object obj)
        {
            object[] ary = (object[])obj;
            string[] strAry = new string[ary.Length];
            for (int i = 0; i < ary.Length; i++)
                strAry[i] = (string)ary[i];
            return new ReadOnlyCollection<string>(strAry);
        }

        public static ReadOnlyCollection<int> ToIntArray(object obj)
        {
            object[] ary = (object[])obj;
            int[] intAry = new int[ary.Length];
            for (int i = 0; i < ary.Length; i++)
                intAry[i] = (int)ary[i];
            return new ReadOnlyCollection<int>(intAry);
        }

        public static ReadOnlyCollection<Role> ToRoleArray(IAzRoles roles)
        {
            List<Role> ary = new List<Role>(roles.Count);
            foreach (IAzRole role in roles)
                ary.Add(new Role(role));
            return new ReadOnlyCollection<Role>(ary);
        }

        public static ReadOnlyCollection<Task> ToTaskArray(IAzTasks tasks)
        {
            List<Task> ary = new List<Task>(tasks.Count);
            foreach (IAzTask task in tasks)
                ary.Add(new Task(task));
            return new ReadOnlyCollection<Task>(ary);
        }

        public static ReadOnlyCollection<Scope> ToScopeArray(IAzScopes scopes)
        {
            List<Scope> ary = new List<Scope>(scopes.Count);
            foreach (IAzScope scope in scopes)
                ary.Add(new Scope(scope));
            return new ReadOnlyCollection<Scope>(ary);
        }

        public static ReadOnlyCollection<Application> ToApplicationArray(IAzApplications applications)
        {
            List<Application> ary = new List<Application>(applications.Count);
            foreach (IAzApplication app in applications)
                ary.Add(new Application(app));
            return new ReadOnlyCollection<Application>(ary);
        }

        public static ReadOnlyCollection<ApplicationGroup> ToApplicationGroupArray(IAzApplicationGroups applicationGroups)
        {
            List<ApplicationGroup> ary = new List<ApplicationGroup>(applicationGroups.Count);
            foreach (IAzApplicationGroup group in applicationGroups)
                ary.Add(new ApplicationGroup(group));
            return new ReadOnlyCollection<ApplicationGroup>(ary);
        }

        public static ReadOnlyCollection<Operation> ToOperationArray(IAzOperations operations)
        {
            List<Operation> ary = new List<Operation>(operations.Count);
            foreach (IAzOperation op in operations)
                ary.Add(new Operation(op));
            return new ReadOnlyCollection<Operation>(ary);
        }
    }
}
